local frame = CreateFrame("Frame");
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("PLAYER_LOGOUT")
frame:RegisterEvent("PLAYER_LOGIN")
frame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
frame:RegisterEvent("COMBAT_LOG_EVENT")
frame:RegisterEvent("TRADE_SKILL_SHOW")

frame:SetScript("OnEvent", function (self, event, ...)
    if event == "ADDON_LOADED" and arg1 == "CDRDB" then
            if CDRDB ~= nil then
                CDR_printCDRData()
            else
                CDRDB = {};
                CDR_printCDRData()
            end
    elseif event == "ADDON_LOADED" and arg1 == "CDRDB_char" then
        if CDRDB_char == nil then
            CDRDB_char = {};
        end
    elseif event == "PLAYER_LOGIN" then
            print("CDR_ Type /cdr help for more informations.");
            CDR_checkCharacterCooldown()
            CDR_deleteDeadCD()
            CDR_printCDRData()
    elseif event == "UNIT_SPELLCAST_SUCCEEDED" then
            local arg1, arg2, arg3 = ...;
            CDR_isTrackedSpell(arg3)
    elseif event == "TRADE_SKILL_SHOW" then
        C_Timer.After(1, CDR_TradeSkillCoolDownControl)
    end
end)

CDR_SPELLS = {
 [17187] = {["cd"] = 172800, ["name"] = "Transmute: Arcanite", ["name_fr"] = "Transmutation d'arcanite", ["Type"] = "Transmute"}, --Arcanite Bar transmute Spell
 [11479] = {["cd"] = 172800, ["name"] = "Transmute: Iron to Gold", ["name_fr"] = "Transmutation : Fer en Or", ["Type"] = "Transmute"},
 [11480] = {["cd"] = 172800, ["name"] = "Transmute: Mithril to Truesilver", ["name_fr"] = "Transmutation de mithril en vrai-argent", ["Type"] = "Transmute"},
 [25146] = {["cd"] = 600, ["name"] = "Transmute: Elemental Fire", ["name_fr"] = "Transmutation : Feu élémentaire", ["Type"] = "Transmute"},
 [17559] = {["cd"] = 172800, ["name"] = "Transmute: Air to Fire", ["name_fr"] = "Transmutation de l'Air en Feu", ["Type"] = "Transmute"},
 [17560] = {["cd"] = 172800, ["name"] = "Transmute: Fire to Earth", ["name_fr"] = "Transmutation du feu en Terre", ["Type"] = "Transmute"},
 [17561] = {["cd"] = 172800, ["name"] = "Transmute: Earth to Water", ["name_fr"] = "Transmutation de la Terre en Eau", ["Type"] = "Transmute"},
 [17562] = {["cd"] = 172800, ["name"] = "Transmute: Water to Air", ["name_fr"] = "Transmutation de l'Eau en Air", ["Type"] = "Transmute"},
 [17563] = {["cd"] = 172800, ["name"] = "Transmute: Undeath to Water", ["name_fr"] = "Transmutation du Non-mort en Eau", ["Type"] = "Transmute"},
 [17564] = {["cd"] = 172800, ["name"] = "Transmute: Water to Undeath", ["name_fr"] = "Transmutation de l'Eau en Non-mort", ["Type"] = "Transmute"},
 [17565] = {["cd"] = 172800, ["name"] = "Transmute: Life to Earth", ["name_fr"] = "Transmutation de la Vie en Terre", ["Type"] = "Transmute"},
 [17566] = {["cd"] = 172800, ["name"] = "Transmute: Earth to Life", ["name_fr"] = "Transmutation de la Terre en Vie", ["Type"] = "Transmute"},
 [19566] = {["cd"] = 259200 , ["name"] = "Salt Shaker", ["Type"] = "Leatherworking"}, --Salt shaker
 [18560] = {["cd"] = 345600 , ["name"] = "Mooncloth", ["Type"] = "Tailoring"}  --MoonCloth SpellCast
}

function CDR_printCDRData()
    local msg = "|cff00ff00 === CooldownReminder Data === \n";
    local size = 0;
    if CDRDB then
        for key, value in pairs(CDRDB) do
            cooldown = CDR_getCooldown(CDRDB[key]["data"]["start"], CDRDB[key]["data"]["duration"]);
            if not cooldown then
                cooldown = "|cff00ff00 available or no data"
            end
            msg = msg .. "|cffffe000 ["..key.."]Char: ".. CDRDB[key]["character"] .. " | CD: " .. CDRDB[key]["data"]["spellname"] .. " Timer: ".. cooldown .. "\n";
            size = size + 1;
        end
        if CDRDB_char then
            for key, value in pairs(CDRDB_char) do
                if CDRDB_char[key]["data"]["cooldown"] == 0 then
                    msg = msg .. "|cffff0000 ["..key.."]Char: ".. CDRDB_char[key]["character"] .. " | CD: " .. CDRDB_char[key]["data"]["spellname"] .. " Timer: AVAILABLE\n";
                    size = size + 1;
                end
            end
        end
    else
        msg = "CooldownRemind: No Data";
    end
    if size > 0 then
        CDR_initMainFrame(msg, size);
        print(msg);
    end
end

function CDR_CooldownReminderCommands(msg, editbox)
    local helpmsg = "=== CooldownRemind Help === \n Type /cdr res or /cdr resume to show your cooldowns \n Type /cdr chk or /cdr check to controls your cooldowns \n Type /cdr reset to force data reset (Need to relog char) \n Type /cdr add 3d20h15m (replace values) to add new cooldown, specific to salt shaker \n Type /cdr del key to delete cooldown item (replace key with the numbers display in the cooldown list between the []";
    local _, _, cmd, args = string.find(msg, "%s?(%w+)%s?(.*)");
    if msg == "resume" or msg == "res" then
        CDR_printCDRData()
    elseif msg == "help" or msg == "?" then
        print(helpmsg);
    elseif msg == "reset" then
        CDR_reset()
    elseif msg == "chk" or msg == "check" then
        CDR_deleteDeadCD()
        CDR_checkCharacterCooldown()
    elseif (cmd == "add" or cmd == "addtimer") and args ~= "" then
        CDR_SetCustomCooldown(args)
    elseif cmd == "del" and args ~= "" then
        CDR_deleteCooldown(args)
    else
        print(helpmsg);
    end
end


SLASH_CDR1, SLASH_CDR2, SLASH_CDR3, SLASH_CDR4 = '/cdr', '/CDR', '/Cdr', '/CDr'

SlashCmdList["CDR"] = CDR_CooldownReminderCommands